Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1319)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1320)
@@ -829,115 +629,115 @@
                 data_output_yz(0:1) = .FALSE.
 
-    REAL ::  advected_distance_x = 0.0, advected_distance_y = 0.0, &
-             alpha_surface = 0.0, atmos_ocean_sign = 1.0, &
-             averaging_interval = 0.0, averaging_interval_pr = 9999999.9, &
-             averaging_interval_sp = 9999999.9, bc_pt_t_val, bc_q_t_val, &
-             bottom_salinityflux = 0.0, &
-             building_height = 50.0, building_length_x = 50.0, &
-             building_length_y = 50.0, building_wall_left = 9999999.9, &
-             building_wall_south = 9999999.9, canyon_height = 50.0, &
-             canyon_width_x = 9999999.9, canyon_width_y = 9999999.9, &
-             canyon_wall_left = 9999999.9, canyon_wall_south = 9999999.9, &
-             cthf = 0.0, cfl_factor = -1.0, cos_alpha_surface, &
-             coupling_start_time = 0.0, disturbance_amplitude = 0.25, &
-             disturbance_energy_limit = 0.01, &
-             disturbance_level_b = -9999999.9, &
-             disturbance_level_t = -9999999.9, &
-             dp_level_b = 0.0, drag_coefficient = 0.0, &
-             dt = -1.0, dt_averaging_input = 0.0, &
-             dt_averaging_input_pr = 9999999.9, dt_coupling = 9999999.9, &
-             dt_data_output = 9999999.9, &
-             dt_data_output_av = 9999999.9, dt_disturb = 9999999.9, &
-             dt_dopr = 9999999.9, dt_dopr_listing = 9999999.9, &
-             dt_dopts = 9999999.9, dt_dosp = 9999999.9, dt_dots = 9999999.9, &
-             dt_do2d_xy = 9999999.9, dt_do2d_xz = 9999999.9, &
-             dt_do2d_yz = 9999999.9, dt_do3d = 9999999.9, dt_dvrp = 9999999.9, &
-             dt_max = 20.0, dt_micro = -1.0, dt_restart = 9999999.9, &
-             dt_run_control = 60.0, dt_3d = -1.0, dz = -1.0, &
-             dz_max = 9999999.9, dz_stretch_factor = 1.08, &
-             dz_stretch_level = 100000.0, e_init = 0.0, e_min = 0.0, &
-             end_time = 0.0, &
-             f = 0.0, fs = 0.0, g = 9.81, inflow_damping_height = 9999999.9, &
-             inflow_damping_width = 9999999.9, kappa = 0.4, km_constant = -1.0,&
-             lad_surface = 0.0, leaf_surface_concentration = 0.0, &
-             mask_scale_x = 1.0, mask_scale_y = 1.0, mask_scale_z = 1.0, &
-             maximum_cpu_time_allowed = 0.0,  &
-             molecular_viscosity = 1.461E-5, &
-             old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
-             particle_maximum_age = 9999999.9, &
-             phi = 55.0, prandtl_number = 1.0, &
-             precipitation_amount_interval = 9999999.9, prho_reference, &
-             pt_damping_factor = 0.0, pt_damping_width = 0.0, &
-             pt_reference = 9999999.9, pt_slope_offset = 0.0, &
-             pt_surface = 300.0, pt_surface_initial_change = 0.0, &
-             q_surface = 0.0, q_surface_initial_change = 0.0, &
-             rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
-             recycling_width = 9999999.9, residual_limit = 1.0E-4, &
-             restart_time = 9999999.9, rho_reference, rho_surface, &
-             rif_max = 1.0, rif_min = -5.0, roughness_length = 0.1, &
-             sa_surface = 35.0, scalar_exchange_coefficient = 0.0, &
-             simulated_time = 0.0, simulated_time_at_begin, sin_alpha_surface, &
-             skip_time_data_output = 0.0, skip_time_data_output_av = 9999999.9,&
-             skip_time_dopr = 9999999.9, skip_time_dosp = 9999999.9, &
-             skip_time_do2d_xy = 9999999.9, skip_time_do2d_xz = 9999999.9, &
-             skip_time_do2d_yz = 9999999.9, skip_time_do3d = 9999999.9, &
-             surface_heatflux = 9999999.9, surface_pressure = 1013.25, &
-             surface_scalarflux = 9999999.9, surface_waterflux = 9999999.9, &
-             s_surface = 0.0, s_surface_initial_change = 0.0, &
-             termination_time_needed = -1.0, time_coupling = 0.0, &
-             time_disturb = 0.0, time_dopr = 0.0, time_dopr_av = 0.0, &
-             time_dopr_listing = 0.0, time_dopts = 0.0, time_dosp = 0.0, &
-             time_dosp_av = 0.0, time_dots = 0.0, time_do2d_xy = 0.0, &
-             time_do2d_xz = 0.0, time_do2d_yz = 0.0, time_do3d = 0.0, &
-             time_do_av = 0.0, time_do_sla = 0.0, time_dvrp = 0.0, &
-             time_restart = 9999999.9, time_run_control = 0.0,&
-             time_since_reference_point, top_heatflux = 9999999.9, &
-             top_momentumflux_u = 9999999.9, &
-             top_momentumflux_v = 9999999.9, top_salinityflux = 9999999.9, &
-             ug_surface = 0.0, u_bulk = 0.0, u_gtrans = 0.0, &
-             vg_surface = 0.0, vpt_reference = 9999999.9, &
-             v_bulk = 0.0, v_gtrans = 0.0, wall_adjustment_factor = 1.8, &
-             z_max_do2d = -1.0, z0h_factor = 1.0
-
-    REAL ::  do2d_xy_last_time(0:1) = -1.0, do2d_xz_last_time(0:1) = -1.0, &
-             do2d_yz_last_time(0:1) = -1.0, dpdxy(1:2) = 0.0, &
-             dt_domask(max_masks) = 9999999.9, lad_vertical_gradient(10) = 0.0,&
-             lad_vertical_gradient_level(10) = -9999999.9, &
-             mask_scale(3), &
-             pt_vertical_gradient(10) = 0.0, &
-             pt_vertical_gradient_level(10) = -9999999.9, &
-             q_vertical_gradient(10) = 0.0, &
-             q_vertical_gradient_level(10) = -1.0, &
-             s_vertical_gradient(10) = 0.0, &
-             s_vertical_gradient_level(10) = -1.0, &
-             sa_vertical_gradient(10) = 0.0, &
-             sa_vertical_gradient_level(10) = -9999999.9, &
-             skip_time_domask(max_masks) = 9999999.9, threshold(20) = 0.0, &
-             time_domask(max_masks) = 0.0, &
-             tsc(10) = (/ 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /), &
-             u_profile(100) = 9999999.9, uv_heights(100) = 9999999.9, &
-             v_profile(100) = 9999999.9, &
-             ug_vertical_gradient(10) = 0.0, &
-             ug_vertical_gradient_level(10) = -9999999.9, &
-             vg_vertical_gradient(10) = 0.0, &
-             vg_vertical_gradient_level(10) = -9999999.9, &
-             volume_flow(1:2) = 0.0, volume_flow_area(1:2) = 0.0, &
-             volume_flow_initial(1:2) = 0.0, wall_heatflux(0:4) = 0.0, &
-             wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, &
-             wall_qflux(0:4) = 0.0, wall_qrflux(0:4) = 0.0, &
-             wall_salinityflux(0:4) = 0.0, wall_scalarflux(0:4) = 0.0, &
-             subs_vertical_gradient(10) = 0.0, &
-             subs_vertical_gradient_level(10) = -9999999.9
-
-    REAL, DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor
-
-    REAL, DIMENSION(max_masks,mask_xyz_dimension) :: &
-        mask_x = -1.0, mask_y = -1.0, mask_z = -1.0
-    REAL, DIMENSION(max_masks,3) ::                  &
-        mask_x_loop = -1.0, mask_y_loop = -1.0, mask_z_loop = -1.0
+    REAL(wp) ::  advected_distance_x = 0.0, advected_distance_y = 0.0, &
+                 alpha_surface = 0.0, atmos_ocean_sign = 1.0, &
+                 averaging_interval = 0.0, averaging_interval_pr = 9999999.9, &
+                 averaging_interval_sp = 9999999.9, bc_pt_t_val, bc_q_t_val, &
+                 bottom_salinityflux = 0.0, &
+                 building_height = 50.0, building_length_x = 50.0, &
+                 building_length_y = 50.0, building_wall_left = 9999999.9, &
+                 building_wall_south = 9999999.9, canyon_height = 50.0, &
+                 canyon_width_x = 9999999.9, canyon_width_y = 9999999.9, &
+                 canyon_wall_left = 9999999.9, canyon_wall_south = 9999999.9, &
+                 cthf = 0.0, cfl_factor = -1.0, cos_alpha_surface, &
+                 coupling_start_time = 0.0, disturbance_amplitude = 0.25, &
+                 disturbance_energy_limit = 0.01, &
+                 disturbance_level_b = -9999999.9, &
+                 disturbance_level_t = -9999999.9, &
+                 dp_level_b = 0.0, drag_coefficient = 0.0, &
+                 dt = -1.0, dt_averaging_input = 0.0, &
+                 dt_averaging_input_pr = 9999999.9, dt_coupling = 9999999.9, &
+                 dt_data_output = 9999999.9, &
+                 dt_data_output_av = 9999999.9, dt_disturb = 9999999.9, &
+                 dt_dopr = 9999999.9, dt_dopr_listing = 9999999.9, &
+                 dt_dopts = 9999999.9, dt_dosp = 9999999.9, dt_dots = 9999999.9, &
+                 dt_do2d_xy = 9999999.9, dt_do2d_xz = 9999999.9, &
+                 dt_do2d_yz = 9999999.9, dt_do3d = 9999999.9, dt_dvrp = 9999999.9, &
+                 dt_max = 20.0, dt_micro = -1.0, dt_restart = 9999999.9, &
+                 dt_run_control = 60.0, dt_3d = -1.0, dz = -1.0, &
+                 dz_max = 9999999.9, dz_stretch_factor = 1.08, &
+                 dz_stretch_level = 100000.0, e_init = 0.0, e_min = 0.0, &
+                 end_time = 0.0, &
+                 f = 0.0, fs = 0.0, g = 9.81, inflow_damping_height = 9999999.9, &
+                 inflow_damping_width = 9999999.9, kappa = 0.4, km_constant = -1.0,&
+                 lad_surface = 0.0, leaf_surface_concentration = 0.0, &
+                 mask_scale_x = 1.0, mask_scale_y = 1.0, mask_scale_z = 1.0, &
+                 maximum_cpu_time_allowed = 0.0,  &
+                 molecular_viscosity = 1.461E-5, &
+                 old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
+                 particle_maximum_age = 9999999.9, &
+                 phi = 55.0, prandtl_number = 1.0, &
+                 precipitation_amount_interval = 9999999.9, prho_reference, &
+                 pt_damping_factor = 0.0, pt_damping_width = 0.0, &
+                 pt_reference = 9999999.9, pt_slope_offset = 0.0, &
+                 pt_surface = 300.0, pt_surface_initial_change = 0.0, &
+                 q_surface = 0.0, q_surface_initial_change = 0.0, &
+                 rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
+                 recycling_width = 9999999.9, residual_limit = 1.0E-4, &
+                 restart_time = 9999999.9, rho_reference, rho_surface, &
+                 rif_max = 1.0, rif_min = -5.0, roughness_length = 0.1, &
+                 sa_surface = 35.0, scalar_exchange_coefficient = 0.0, &
+                 simulated_time = 0.0, simulated_time_at_begin, sin_alpha_surface, &
+                 skip_time_data_output = 0.0, skip_time_data_output_av = 9999999.9,&
+                 skip_time_dopr = 9999999.9, skip_time_dosp = 9999999.9, &
+                 skip_time_do2d_xy = 9999999.9, skip_time_do2d_xz = 9999999.9, &
+                 skip_time_do2d_yz = 9999999.9, skip_time_do3d = 9999999.9, &
+                 surface_heatflux = 9999999.9, surface_pressure = 1013.25, &
+                 surface_scalarflux = 9999999.9, surface_waterflux = 9999999.9, &
+                 s_surface = 0.0, s_surface_initial_change = 0.0, &
+                 termination_time_needed = -1.0, time_coupling = 0.0, &
+                 time_disturb = 0.0, time_dopr = 0.0, time_dopr_av = 0.0, &
+                 time_dopr_listing = 0.0, time_dopts = 0.0, time_dosp = 0.0, &
+                 time_dosp_av = 0.0, time_dots = 0.0, time_do2d_xy = 0.0, &
+                 time_do2d_xz = 0.0, time_do2d_yz = 0.0, time_do3d = 0.0, &
+                 time_do_av = 0.0, time_do_sla = 0.0, time_dvrp = 0.0, &
+                 time_restart = 9999999.9, time_run_control = 0.0,&
+                 time_since_reference_point, top_heatflux = 9999999.9, &
+                 top_momentumflux_u = 9999999.9, &
+                 top_momentumflux_v = 9999999.9, top_salinityflux = 9999999.9, &
+                 ug_surface = 0.0, u_bulk = 0.0, u_gtrans = 0.0, &
+                 vg_surface = 0.0, vpt_reference = 9999999.9, &
+                 v_bulk = 0.0, v_gtrans = 0.0, wall_adjustment_factor = 1.8, &
+                 z_max_do2d = -1.0, z0h_factor = 1.0
+
+    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0, do2d_xz_last_time(0:1) = -1.0, &
+                 do2d_yz_last_time(0:1) = -1.0, dpdxy(1:2) = 0.0, &
+                 dt_domask(max_masks) = 9999999.9, lad_vertical_gradient(10) = 0.0,&
+                 lad_vertical_gradient_level(10) = -9999999.9, &
+                 mask_scale(3), &
+                 pt_vertical_gradient(10) = 0.0, &
+                 pt_vertical_gradient_level(10) = -9999999.9, &
+                 q_vertical_gradient(10) = 0.0, &
+                 q_vertical_gradient_level(10) = -1.0, &
+                 s_vertical_gradient(10) = 0.0, &
+                 s_vertical_gradient_level(10) = -1.0, &
+                 sa_vertical_gradient(10) = 0.0, &
+                 sa_vertical_gradient_level(10) = -9999999.9, &
+                 skip_time_domask(max_masks) = 9999999.9, threshold(20) = 0.0, &
+                 time_domask(max_masks) = 0.0, &
+                 tsc(10) = (/ 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /), &
+                 u_profile(100) = 9999999.9, uv_heights(100) = 9999999.9, &
+                 v_profile(100) = 9999999.9, &
+                 ug_vertical_gradient(10) = 0.0, &
+                 ug_vertical_gradient_level(10) = -9999999.9, &
+                 vg_vertical_gradient(10) = 0.0, &
+                 vg_vertical_gradient_level(10) = -9999999.9, &
+                 volume_flow(1:2) = 0.0, volume_flow_area(1:2) = 0.0, &
+                 volume_flow_initial(1:2) = 0.0, wall_heatflux(0:4) = 0.0, &
+                 wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, &
+                 wall_qflux(0:4) = 0.0, wall_qrflux(0:4) = 0.0, &
+                 wall_salinityflux(0:4) = 0.0, wall_scalarflux(0:4) = 0.0, &
+                 subs_vertical_gradient(10) = 0.0, &
+                 subs_vertical_gradient_level(10) = -9999999.9
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor
+
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) :: &
+            mask_x = -1.0, mask_y = -1.0, mask_z = -1.0
+    REAL(wp), DIMENSION(max_masks,3) ::                  &
+            mask_x_loop = -1.0, mask_y_loop = -1.0, mask_z_loop = -1.0
     
 !
 !--    internal mask arrays ("mask,dimension,selection")
-       REAL, DIMENSION(:,:,:), ALLOCATABLE ::  mask, mask_loop
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask, mask_loop
 
     SAVE
@@ -954,4 +754,6 @@
 ! Definition of variables used with dvrp-software
 !------------------------------------------------------------------------------!
+
+     USE kinds
 
     CHARACTER (LEN=10) ::  dvrp_output = 'rtsp', particle_color = 'none', &
@@ -967,14 +769,14 @@
                            dvrp_username  = ' '
 
-    INTEGER ::  cluster_size = 1, dvrp_colortable_entries = 4,                 &
-                dvrp_colortable_entries_prt = 22, islice_dvrp,                 &
-                nx_dvrp, nxl_dvrp, nxr_dvrp, ny_dvrp, nyn_dvrp, nys_dvrp,      &
-                nz_dvrp, pathlines_fadeintime = 5, pathlines_fadeouttime = 5,  &
-                pathlines_linecount = 1000, pathlines_maxhistory = 40,         &
-                pathlines_wavecount = 10, pathlines_wavetime = 50,             &
-                vc_gradient_normals = 0, vc_mode = 0, vc_size_x = 2,           &
-                vc_size_y = 2, vc_size_z = 2
-
-    INTEGER, DIMENSION(10) ::  slicer_position_dvrp
+    INTEGER(iwp) ::  cluster_size = 1, dvrp_colortable_entries = 4,                 &
+                     dvrp_colortable_entries_prt = 22, islice_dvrp,                 &
+                     nx_dvrp, nxl_dvrp, nxr_dvrp, ny_dvrp, nyn_dvrp, nys_dvrp,      &
+                     nz_dvrp, pathlines_fadeintime = 5, pathlines_fadeouttime = 5,  &
+                     pathlines_linecount = 1000, pathlines_maxhistory = 40,         &
+                     pathlines_wavecount = 10, pathlines_wavetime = 50,             &
+                     vc_gradient_normals = 0, vc_mode = 0, vc_size_x = 2,           &
+                     vc_size_y = 2, vc_size_z = 2
+
+    INTEGER(iwp), DIMENSION(10) ::  slicer_position_dvrp
 
     LOGICAL ::  cyclic_dvrp = .FALSE., dvrp_overlap, dvrp_total_overlap, &
@@ -982,53 +784,53 @@
                 use_seperate_pe_for_dvrp_output = .FALSE.
 
-    REAL    ::  clip_dvrp_l = 9999999.9, clip_dvrp_n = 9999999.9, &
-                clip_dvrp_r = 9999999.9, clip_dvrp_s = 9999999.9, &
-                superelevation = 1.0, superelevation_x = 1.0,     &
-                superelevation_y = 1.0, vc_alpha = 38.0
-
-    REAL, DIMENSION(2) ::  color_interval = (/ 0.0, 1.0 /), &
-                           dvrpsize_interval = (/ 0.0, 1.0 /)
-
-    REAL, DIMENSION(3) ::  groundplate_color = (/ 0.0, 0.6, 0.0 /), &
-                           topography_color = (/ 0.8, 0.7, 0.6 /)
+    REAL(wp)    ::  clip_dvrp_l = 9999999.9, clip_dvrp_n = 9999999.9, &
+                    clip_dvrp_r = 9999999.9, clip_dvrp_s = 9999999.9, &
+                    superelevation = 1.0, superelevation_x = 1.0,     &
+                    superelevation_y = 1.0, vc_alpha = 38.0
+
+    REAL(wp), DIMENSION(2) ::  color_interval = (/ 0.0, 1.0 /), &
+                               dvrpsize_interval = (/ 0.0, 1.0 /)
+
+    REAL(wp), DIMENSION(3) ::  groundplate_color = (/ 0.0, 0.6, 0.0 /), &
+                               topography_color = (/ 0.8, 0.7, 0.6 /)
 
 #if defined( __decalpha )
-    REAL, DIMENSION(2,10)  ::  slicer_range_limits_dvrp = RESHAPE( (/       &
-                                -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
-                                -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
-                                -1.0, 1.0, -1.0, 1.0 /), (/ 2, 10 /) )
-
-    REAL, DIMENSION(3,10)  ::  isosurface_color = RESHAPE( (/                  &
-                                0.9, 0.9, 0.9,  0.8, 0.1, 0.1,  0.1, 0.1, 0.8, &
-                                0.1, 0.8, 0.1,  0.6, 0.1, 0.1,  0.1, 0.1, 0.6, &
-                                0.1, 0.6, 0.1,  0.4, 0.1, 0.1,  0.1, 0.1, 0.4, &
-                                0.1, 0.4, 0.1 /), (/ 3, 10 /) )
-
-    REAL(4), DIMENSION(2,100) ::  interval_values_dvrp, interval_h_dvrp =      &
-                                  RESHAPE( (/ 270.0, 225.0, 225.0, 180.0,      &
-                                               70.0,  25.0,  25.0, -25.0,      &
-                                              ( 0.0, i9 = 1, 192 ) /),         &
-                                           (/ 2, 100 /) ),                     &
-                                  interval_l_dvrp = 0.5, interval_s_dvrp = 1.0,&
-                                  interval_a_dvrp = 0.0,                       &
-                                  interval_values_dvrp_prt,                    &
-                                  interval_h_dvrp_prt = RESHAPE(               &
-                                  (/ 270.0, 225.0, 225.0, 180.0, 70.0, 25.0,   &
-                                     25.0, -25.0, ( 0.0, i9 = 1, 192 ) /),     &
-                                                  (/ 2, 100 /) ),              &
-                                  interval_l_dvrp_prt = 0.5,                   &
-                                  interval_s_dvrp_prt = 1.0,                   &
-                                  interval_a_dvrp_prt = 0.0
+    REAL(wp), DIMENSION(2,10)  ::  slicer_range_limits_dvrp = RESHAPE( (/      &
+                                   -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                   -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                   -1.0, 1.0, -1.0, 1.0 /), (/ 2, 10 /) )
+
+    REAL(wp), DIMENSION(3,10)  ::  isosurface_color = RESHAPE( (/                 &
+                                   0.9, 0.9, 0.9,  0.8, 0.1, 0.1,  0.1, 0.1, 0.8, &
+                                   0.1, 0.8, 0.1,  0.6, 0.1, 0.1,  0.1, 0.1, 0.6, &
+                                   0.1, 0.6, 0.1,  0.4, 0.1, 0.1,  0.1, 0.1, 0.4, &
+                                   0.1, 0.4, 0.1 /), (/ 3, 10 /) )
+
+    REAL(sp), DIMENSION(2,100) ::  interval_values_dvrp, interval_h_dvrp =      &
+                                   RESHAPE( (/ 270.0, 225.0, 225.0, 180.0,      &
+                                                70.0,  25.0,  25.0, -25.0,      &
+                                               ( 0.0, i9 = 1, 192 ) /),         &
+                                            (/ 2, 100 /) ),                     &
+                                   interval_l_dvrp = 0.5, interval_s_dvrp = 1.0,&
+                                   interval_a_dvrp = 0.0,                       &
+                                   interval_values_dvrp_prt,                    &
+                                   interval_h_dvrp_prt = RESHAPE(               &
+                                   (/ 270.0, 225.0, 225.0, 180.0, 70.0, 25.0,   &
+                                      25.0, -25.0, ( 0.0, i9 = 1, 192 ) /),     &
+                                                   (/ 2, 100 /) ),              &
+                                   interval_l_dvrp_prt = 0.5,                   &
+                                   interval_s_dvrp_prt = 1.0,                   &
+                                   interval_a_dvrp_prt = 0.0
 #else
-    REAL, DIMENSION(2,10)     ::  slicer_range_limits_dvrp
-
-    REAL, DIMENSION(3,10)     ::  isosurface_color
-
-    REAL(4), DIMENSION(2,100) ::  interval_values_dvrp,                       &
-                                  interval_values_dvrp_prt, interval_h_dvrp,  &
-                                  interval_h_dvrp_prt, interval_l_dvrp = 0.5, &
-                                  interval_l_dvrp_prt = 0.5, interval_s_dvrp = 1.0, &
-                                  interval_s_dvrp_prt = 1.0, interval_a_dvrp = 0.0, &
-                                  interval_a_dvrp_prt = 0.0
+    REAL(wp), DIMENSION(2,10)     ::  slicer_range_limits_dvrp
+
+    REAL(wp), DIMENSION(3,10)     ::  isosurface_color
+
+    REAL(sp), DIMENSION(2,100) ::  interval_values_dvrp,                       &
+                                   interval_values_dvrp_prt, interval_h_dvrp,  &
+                                   interval_h_dvrp_prt, interval_l_dvrp = 0.5, &
+                                   interval_l_dvrp_prt = 0.5, interval_s_dvrp = 1.0, &
+                                   interval_s_dvrp_prt = 1.0, interval_a_dvrp = 0.0, &
+                                   interval_a_dvrp_prt = 0.0
 
     DATA  slicer_range_limits_dvrp / -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
@@ -1049,10 +851,10 @@
 #endif
 
-    REAL(4), DIMENSION(:), ALLOCATABLE ::  xcoor_dvrp, ycoor_dvrp, zcoor_dvrp
+    REAL(sp), DIMENSION(:), ALLOCATABLE ::  xcoor_dvrp, ycoor_dvrp, zcoor_dvrp
 
     TYPE steering
        CHARACTER (LEN=24) ::  name
-       REAL(4)            ::  min, max
-       INTEGER            ::  imin, imax
+       REAL(sp)           ::  min, max
+       INTEGER(iwp)       ::  imin, imax
     END TYPE steering
 
@@ -1074,12 +876,14 @@
 !------------------------------------------------------------------------------!
 
-    REAL ::  ddx, ddx2, dx = 1.0, dx2, ddy, ddy2, dy = 1.0, dy2
-
-    REAL, DIMENSION(:), ALLOCATABLE ::  ddx2_mg, ddy2_mg
-
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  fwxm, fwxp, fwym, fwyp, fxm, fxp,   &
-                                          fym, fyp, wall_e_x, wall_e_y,       &
-                                          wall_u, wall_v, wall_w_x, wall_w_y, &
-                                          zu_s_inner, zw_w_inner
+    USE kinds
+
+    REAL(wp) ::  ddx, ddx2, dx = 1.0, dx2, ddy, ddy2, dy = 1.0, dy2
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddx2_mg, ddy2_mg
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwxm, fwxp, fwym, fwyp, fxm, fxp,   &
+                                              fym, fyp, wall_e_x, wall_e_y,       &
+                                              wall_u, wall_v, wall_w_x, wall_w_y, &
+                                              zu_s_inner, zw_w_inner
 
     SAVE
@@ -1098,33 +902,35 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER ::  i_left, i_right, j_north, j_south, nbgp = 3, ngp_sums, nnx,    &
-                nx = 0, nx_a, nx_o, nxl, nxlg, nxlu, nxr, nxrg, nx_on_file,    &
-                nny, ny = 0, ny_a, ny_o, nyn, nyng, nys, nysg, nysv,           &
-                ny_on_file, nnz, nz = 0, nzb, nzb_diff, nzb_max, nzt, nzt_diff
-
-
-    INTEGER( KIND = SELECTED_INT_KIND(18) ), DIMENSION(:), ALLOCATABLE ::      &
+    USE kinds
+
+    INTEGER(iwp) ::  i_left, i_right, j_north, j_south, nbgp = 3, ngp_sums, nnx,    &
+                     nx = 0, nx_a, nx_o, nxl, nxlg, nxlu, nxr, nxrg, nx_on_file,    &
+                     nny, ny = 0, ny_a, ny_o, nyn, nyng, nys, nysg, nysv,           &
+                     ny_on_file, nnz, nz = 0, nzb, nzb_diff, nzb_max, nzt, nzt_diff
+
+
+    INTEGER(idp), DIMENSION(:), ALLOCATABLE ::      &
                 ngp_3d, ngp_3d_inner   ! need to have 64 bit for grids > 2E9
 
-    INTEGER, DIMENSION(:), ALLOCATABLE ::                                      &
-                ngp_2dh, nxl_mg, nxr_mg, nyn_mg, nys_mg, nzt_mg
-
-
-    INTEGER, DIMENSION(:,:), ALLOCATABLE :: ngp_2dh_outer, ngp_2dh_s_inner,    &
-                mg_loc_ind, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u,    &
-                nzb_diff_v, nzb_inner, nzb_outer, nzb_s_inner, nzb_s_outer,    &
-                nzb_u_inner, nzb_u_outer, nzb_v_inner, nzb_v_outer,            &
-                nzb_w_inner, nzb_w_outer, nzb_2d
-
-    INTEGER, DIMENSION(:,:,:), POINTER ::  flags
-
-    INTEGER, DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0, wall_flags_00
-
-    INTEGER, DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::                         &
-                wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,        &
-                wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,        &
-                wall_flags_9, wall_flags_10
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  rflags_s_inner, rflags_invers
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::                                  &
+                   ngp_2dh, nxl_mg, nxr_mg, nyn_mg, nys_mg, nzt_mg
+
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: ngp_2dh_outer, ngp_2dh_s_inner,  &
+                   mg_loc_ind, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u,    &
+                   nzb_diff_v, nzb_inner, nzb_outer, nzb_s_inner, nzb_s_outer,    &
+                   nzb_u_inner, nzb_u_outer, nzb_v_inner, nzb_v_outer,            &
+                   nzb_w_inner, nzb_w_outer, nzb_2d
+
+    INTEGER(iwp), DIMENSION(:,:,:), POINTER ::  flags
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0, wall_flags_00
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::                       &
+                   wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,        &
+                   wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,        &
+                   wall_flags_9, wall_flags_10
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rflags_s_inner, rflags_invers
 
     SAVE
@@ -1147,11 +953,14 @@
        SUBROUTINE global_min_max ( i1, i2, j1, j2, k1, k2, feld, mode, offset, &
                                    wert, wert_ijk, wert1, wert1_ijk )
-          CHARACTER (LEN=*), INTENT(IN) ::  mode
-          INTEGER, INTENT(IN)           ::  i1, i2, j1, j2, k1, k2
-          INTEGER                       ::  wert_ijk(3)
-          INTEGER, OPTIONAL             ::  wert1_ijk(3)
-          REAL                          ::  offset, wert
-          REAL, OPTIONAL                ::  wert1
-          REAL, INTENT(IN)              ::  feld(i1:i2,j1:j2,k1:k2)
+
+          USE kinds
+
+          CHARACTER (LEN=*), INTENT(IN)      ::  mode
+          INTEGER(iwp), INTENT(IN)           ::  i1, i2, j1, j2, k1, k2
+          INTEGER(iwp)                       ::  wert_ijk(3)
+          INTEGER(iwp), OPTIONAL             ::  wert1_ijk(3)
+          REAL(wp)                           ::  offset, wert
+          REAL(wp), OPTIONAL                 ::  wert1
+          REAL(wp), INTENT(IN)               ::  feld(i1:i2,j1:j2,k1:k2)
 
        END SUBROUTINE global_min_max
@@ -1178,9 +987,11 @@
        SUBROUTINE advec_s_bc( sk, sk_char )
 
+          USE kinds
+
           CHARACTER (LEN=*), INTENT(IN)   ::  sk_char
 #if defined( __nopointer )
-          REAL, DIMENSION(:,:,:) ::  sk
+          REAL(wp), DIMENSION(:,:,:) ::  sk
 #else
-          REAL, DIMENSION(:,:,:), POINTER ::  sk
+          REAL(wp), DIMENSION(:,:,:), POINTER ::  sk
 #endif
        END SUBROUTINE advec_s_bc
@@ -1204,19 +1015,21 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER ::  current_timestep_number_1d = 0, damp_level_ind_1d
+    USE kinds
+
+    INTEGER(iwp) ::  current_timestep_number_1d = 0, damp_level_ind_1d
 
     LOGICAL ::  run_control_header_1d = .FALSE., stop_dt_1d = .FALSE. 
 
-    REAL ::     damp_level_1d = -1.0, dt_1d = 60.0, dt_max_1d = 300.0, &
-                dt_pr_1d = 9999999.9, dt_run_control_1d = 60.0, &
-                end_time_1d = 864000.0, old_dt_1d = 1.0E-10, &
-                qs1d, simulated_time_1d = 0.0, time_pr_1d = 0.0, &
-                time_run_control_1d = 0.0, ts1d, us1d, usws1d, &
-                vsws1d, z01d, z0h1d
-
-
-    REAL, DIMENSION(:), ALLOCATABLE ::  e1d, e1d_p, kh1d, km1d, l_black, l1d,  &
-                                        rif1d, te_e, te_em, te_u, te_um, te_v, &
-                                        te_vm, u1d, u1d_p, v1d, v1d_p
+    REAL(wp) ::     damp_level_1d = -1.0, dt_1d = 60.0, dt_max_1d = 300.0, &
+                    dt_pr_1d = 9999999.9, dt_run_control_1d = 60.0, &
+                    end_time_1d = 864000.0, old_dt_1d = 1.0E-10, &
+                    qs1d, simulated_time_1d = 0.0, time_pr_1d = 0.0, &
+                    time_run_control_1d = 0.0, ts1d, us1d, usws1d, &
+                    vsws1d, z01d, z0h1d
+
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  e1d, e1d_p, kh1d, km1d, l_black, l1d,  &
+                                            rif1d, te_e, te_em, te_u, te_um, te_v, &
+                                            te_vm, u1d, u1d_p, v1d, v1d_p
 
     SAVE
@@ -1235,12 +1048,13 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
+    USE control_parameters, ONLY: max_masks
+    USE kinds
 #if defined( __netcdf )
     USE netcdf
 #endif
 
-    INTEGER, PARAMETER ::  dopr_norm_num = 7, dopts_num = 29, dots_max = 100
-
-    INTEGER ::  dots_num = 23
+    INTEGER(iwp), PARAMETER ::  dopr_norm_num = 7, dopts_num = 29, dots_max = 100
+
+    INTEGER(iwp) ::  dots_num = 23
 
     CHARACTER (LEN=6), DIMENSION(dopr_norm_num) ::  dopr_norm_names =   &
